//+------------------------------------------------------------------+
//|                                             Ambush_Cable_M30.mq4 |
//|                                           kris.pivo[at]gmail.com |
//|          Based on David Willis' TheOnlyPivot_multi.mq4 indicator |
//|            Expert Advisor optimised for GBP/USD in M30 timeframe |
//|                                             on IBFX platform GMT |
//| Note: it crashes MT4 in any other timeframe!                     |
//+------------------------------------------------------------------+
#property copyright " Kris, 2008"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 DarkGreen
#property indicator_color2 DarkGreen
#property indicator_color3 Silver
#property indicator_color4 Yellow
#property indicator_color5 Yellow
#property indicator_color6 Silver
#property indicator_color7 Maroon
#property indicator_color8 Maroon

//---- input parameters
extern int JP_open =  3; // the Hour to Start
extern int EU_open =  8;
extern int US_open = 13;

//---- buffers
double ExtMapBuffer0[];  // Fibonacci Extension +1.618
double ExtMapBuffer1[];  // Fibonacci Extension +1.272
double ExtMapBuffer2[];  // Previous Session High
double ExtMapBuffer3[];  // Fibonacci 0.618
double ExtMapBuffer4[];  // Fibonacci 0.382
double ExtMapBuffer5[];  // Previous Session Low
double ExtMapBuffer6[];  // Fibonacci Extension -1.272
double ExtMapBuffer7[];  // Fibonacci Extension -1.618
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE, STYLE_DOT, 1);  // Long Profit Target 3 - Fibonacci 1.618 extension
   SetIndexBuffer(0,ExtMapBuffer0);
   SetIndexLabel(0,"Fibonacci Extension +1.618");
   
   SetIndexStyle(1,DRAW_LINE, STYLE_DOT, 1);  // Long Profit Target 2 - Fibonacci 1.272 extension
   SetIndexBuffer(1,ExtMapBuffer1);
   SetIndexLabel(1,"Fibonacci Extension +1.272"); 
   
   SetIndexStyle(2,DRAW_LINE, STYLE_DOT, 1);  // Long Profit Target 1 - Previous Session High - Fibonacci 1.000 
   SetIndexBuffer(2,ExtMapBuffer2);
   SetIndexLabel(2,"Previous Session High"); 

   SetIndexStyle(3,DRAW_LINE, STYLE_SOLID, 1);  // LONG ENTRY - Fibonacci 0.618
   SetIndexBuffer(3,ExtMapBuffer3);
   SetIndexLabel(3,"Fibonacci 0.618"); 
   
   SetIndexStyle(4,DRAW_LINE, STYLE_SOLID, 1);    // SHORT ENTRY - Fibonacci 0.382
   SetIndexBuffer(4,ExtMapBuffer4);
   SetIndexLabel(4,"Fibonacci 0.382"); 
   
   SetIndexStyle(5,DRAW_LINE, STYLE_DOT, 1);    // Short Profit Target 1 - Previous Session Low
   SetIndexBuffer(5,ExtMapBuffer5);
   SetIndexLabel(5,"Previous Session Low"); 

   SetIndexStyle(6,DRAW_LINE, STYLE_DOT, 1);    // Short Profit Target 2 - Fibonacci 1.272 extension
   SetIndexBuffer(6,ExtMapBuffer6);
   SetIndexLabel(6,"Fibonacci Extension -1.272"); 
   
   SetIndexStyle(7,DRAW_LINE, STYLE_DOT, 1);    // Short Profit Target 3 - Fibonacci 1.618 extension
   SetIndexBuffer(7,ExtMapBuffer7);
   SetIndexLabel(7,"Fibonacci Extension -1.618"); 
   
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int session(int i)
{
 int hour=TimeHour(iTime(NULL,0,i));
 int session=0;
      // find session....1=Tokyo,2=London,3=NYC
      
      if(JP_open < EU_open)
      {
      if(hour>=JP_open && hour<EU_open){session=1;}
      }
      else
      {
      if(hour>=JP_open || hour<EU_open){session=1;}
      }
      if(EU_open < US_open)
      {
      if(hour>=EU_open && hour<US_open){session=2;}
      }
      else
      {
      if(hour>=EU_open || hour<US_open){session=2;}
      }
      if(US_open < JP_open)
      {
      if(hour>=US_open && hour<JP_open){session=3;}
      }
      else
      {
      if(hour>=US_open || hour<JP_open){session=3;}
      }
      
 return(session);
 }    
  
int start()
  {
     double PivotPoint, PivotDiff, PivotRangeHigh, PivotRangeLow;
     double PreviousSessionHigh, PreviousSessionLow;
     double Fib0618, Fib0382;
     double FibExtP1272, FibExtP1618;
     double FibExtN1272, FibExtN1618;
     int high,low,close;
     int startime,start,end,hour,cnt,session;
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     int limit = Bars-counted_bars;
     if(limit>Bars-48){limit=Bars-48;}
  //---- main loop
     for (int i=limit; i >= 0; i--)
     {
      session=session(i);
   
     if(session==1)
     {
      for(cnt=i;session(cnt)!=2;cnt++)
      {
       if(session(cnt)==3)
       {
        if(session(cnt-1)==1)
        {
         close=cnt;
         high=cnt;
         low=cnt;
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     if(session==2)
     {
      for(cnt=i;session(cnt)!=3;cnt++)
      {
       if(session(cnt)==1)
       {
        if(session(cnt-1)==2)
        {
         close=cnt;
         high=cnt;
         low=cnt;         
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     if(session==3)
     {
      for(cnt=i;session(cnt)!=1;cnt++)
      {
       if(session(cnt)==2)
       {
        if(session(cnt-1)==3)
        {
         close=cnt;
         high=cnt;
         low=cnt;
        }
        if(High[cnt]>High[high]){high=cnt;}
        if(Low[cnt]<Low[low]){low=cnt;}
       } } }
     
     FibExtP1618 = High[high] + (High[high]-Low[low]) * 0.618;
     FibExtP1272 = High[high] + (High[high]-Low[low]) * 0.272;
     PreviousSessionHigh = High[high];
     Fib0618     = Low[low]   + (High[high]-Low[low]) * 0.618;
     Fib0382     = Low[low]   + (High[high]-Low[low]) * 0.382;
     PreviousSessionLow  = Low[low];
     FibExtN1272 = Low[low] - (High[high]-Low[low]) * 0.272;
     FibExtN1618 = Low[low] - (High[high]-Low[low]) * 0.618;
     
     ExtMapBuffer0[i]=FibExtP1618; 
     ExtMapBuffer1[i]=FibExtP1272;
     ExtMapBuffer2[i]=PreviousSessionHigh;
     ExtMapBuffer3[i]=Fib0618;
     ExtMapBuffer4[i]=Fib0382;
     ExtMapBuffer5[i]=PreviousSessionLow;
     ExtMapBuffer6[i]=FibExtN1272;
     ExtMapBuffer7[i]=FibExtN1618;
    }   
     return(0);
    }
//+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+